% Lezione di lab TTR  -19/04/2017- LDA + KNN - Marco Cristani

% Caricare il file iris.mat
% (dataset di 150 oggetti in uno spazio 4-dimensionale)
% 1) Calcolare la matrice di trasformazione W utilizzando la (Fisher)
% Linear Discriminant analysis
% 2)Ridurre la dimensionalit del dataset a due e visualizzarlo
% visualizzare le varie classi con simboli diversi. Confrontarlo con 
% quanto ottenuto in PCA
% 3) Eseguire classificazione con cross validazione 10-fold 
%    con KNN (implementarsi KNN per i piu' audaci!)
%    con K a piacere, usando il training set nella sua
%    dimensionalita' originale, e ridotto attraverso PCA, e Fisher. 
%    Calcolare nei tre casi le matrici di confusione risultanti.

% Risoluzione dell'esercizio 1)
clear all
%close all
load 'irisSet.mat'

[d,N] = size(X);
K = max(l); % numero classi in gioco;

% 1. determino le classi Ck
for k = 1:K
    a = find (l == k);
    Ck{k} = X(:,a);
end
% 2. determino le medie
for k = 1:K
    mk{k} = mean(Ck{k},2);
end
% 3. determino la numerosit della classe
for k = 1:K
    [d, Nk(k)] = size(Ck{k});
end
% 4. determino le within class covariance
for k = 1:K
    S{k} = 0;
    for i = 1:Nk(k)
        S{k} = S{k} + (Ck{k}(:,i)-mk{k})*(Ck{k}(:,i)-mk{k})';
    end
    S{k} = S{k}./Nk(k);
end
Swx = 0;
for k = 1:K
    Swx = Swx + S{k};
end

% 5. determino la between class covariance
% 5.1 determino la media totale
m = mean(X,2);
Sbx = 0;
for k=1:K
    Sbx = Sbx + Nk(k)*((mk{k} - m)*(mk{k} - m)');
end
Sbx = Sbx/K;

MA = inv(Swx)*Sbx;

% eigenvalues/eigenvectors
[V,D] = eig(MA);

% 5: transform matrix
W = V(:,1:2);

% 6: transformation
Y = W'*X;

% 7: plot
figure, scatter(Y(1,:),Y(2,:),[],l)


